# coding: utf-8

"""
    Pathnexus

    Pathnexus - a lab data harmonisation platform  # noqa: E501

    OpenAPI spec version: 4.6.0-SNAPSHOT
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from pathnexus_client.com.termlex.pathnexus.model.concept_map_group_unmapped_component import ConceptMapGroupUnmappedComponent  # noqa: F401,E501
from pathnexus_client.com.termlex.pathnexus.model.extension import Extension  # noqa: F401,E501
from pathnexus_client.com.termlex.pathnexus.model.source_element_component import SourceElementComponent  # noqa: F401,E501
from pathnexus_client.com.termlex.pathnexus.model.string_type import StringType  # noqa: F401,E501
from pathnexus_client.com.termlex.pathnexus.model.uri_type import UriType  # noqa: F401,E501


class ConceptMapGroupComponent(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'format_comments_pre': 'list[str]',
        'format_comments_post': 'list[str]',
        'id': 'str',
        'extension': 'list[Extension]',
        'disallow_extensions': 'bool',
        'modifier_extension': 'list[Extension]',
        'source': 'str',
        'source_version': 'str',
        'target': 'str',
        'target_version': 'str',
        'element': 'list[SourceElementComponent]',
        'unmapped': 'ConceptMapGroupUnmappedComponent',
        'source_element': 'UriType',
        'source_version_element': 'StringType',
        'target_element': 'UriType',
        'target_version_element': 'StringType',
        'element_first_rep': 'SourceElementComponent',
        'empty': 'bool',
        'modifier_extension_first_rep': 'Extension',
        'extension_first_rep': 'Extension',
        'id_element': 'StringType',
        'id_base': 'str',
        'primitive': 'bool',
        'resource': 'bool',
        'boolean_primitive': 'bool',
        'date_time': 'bool'
    }

    attribute_map = {
        'format_comments_pre': 'formatCommentsPre',
        'format_comments_post': 'formatCommentsPost',
        'id': 'id',
        'extension': 'extension',
        'disallow_extensions': 'disallowExtensions',
        'modifier_extension': 'modifierExtension',
        'source': 'source',
        'source_version': 'sourceVersion',
        'target': 'target',
        'target_version': 'targetVersion',
        'element': 'element',
        'unmapped': 'unmapped',
        'source_element': 'sourceElement',
        'source_version_element': 'sourceVersionElement',
        'target_element': 'targetElement',
        'target_version_element': 'targetVersionElement',
        'element_first_rep': 'elementFirstRep',
        'empty': 'empty',
        'modifier_extension_first_rep': 'modifierExtensionFirstRep',
        'extension_first_rep': 'extensionFirstRep',
        'id_element': 'idElement',
        'id_base': 'idBase',
        'primitive': 'primitive',
        'resource': 'resource',
        'boolean_primitive': 'booleanPrimitive',
        'date_time': 'dateTime'
    }

    def __init__(self, format_comments_pre=None, format_comments_post=None, id=None, extension=None, disallow_extensions=None, modifier_extension=None, source=None, source_version=None, target=None, target_version=None, element=None, unmapped=None, source_element=None, source_version_element=None, target_element=None, target_version_element=None, element_first_rep=None, empty=None, modifier_extension_first_rep=None, extension_first_rep=None, id_element=None, id_base=None, primitive=None, resource=None, boolean_primitive=None, date_time=None):  # noqa: E501
        """ConceptMapGroupComponent - a model defined in Swagger"""  # noqa: E501

        self._format_comments_pre = None
        self._format_comments_post = None
        self._id = None
        self._extension = None
        self._disallow_extensions = None
        self._modifier_extension = None
        self._source = None
        self._source_version = None
        self._target = None
        self._target_version = None
        self._element = None
        self._unmapped = None
        self._source_element = None
        self._source_version_element = None
        self._target_element = None
        self._target_version_element = None
        self._element_first_rep = None
        self._empty = None
        self._modifier_extension_first_rep = None
        self._extension_first_rep = None
        self._id_element = None
        self._id_base = None
        self._primitive = None
        self._resource = None
        self._boolean_primitive = None
        self._date_time = None
        self.discriminator = None

        if format_comments_pre is not None:
            self.format_comments_pre = format_comments_pre
        if format_comments_post is not None:
            self.format_comments_post = format_comments_post
        if id is not None:
            self.id = id
        if extension is not None:
            self.extension = extension
        if disallow_extensions is not None:
            self.disallow_extensions = disallow_extensions
        if modifier_extension is not None:
            self.modifier_extension = modifier_extension
        if source is not None:
            self.source = source
        if source_version is not None:
            self.source_version = source_version
        if target is not None:
            self.target = target
        if target_version is not None:
            self.target_version = target_version
        if element is not None:
            self.element = element
        if unmapped is not None:
            self.unmapped = unmapped
        if source_element is not None:
            self.source_element = source_element
        if source_version_element is not None:
            self.source_version_element = source_version_element
        if target_element is not None:
            self.target_element = target_element
        if target_version_element is not None:
            self.target_version_element = target_version_element
        if element_first_rep is not None:
            self.element_first_rep = element_first_rep
        if empty is not None:
            self.empty = empty
        if modifier_extension_first_rep is not None:
            self.modifier_extension_first_rep = modifier_extension_first_rep
        if extension_first_rep is not None:
            self.extension_first_rep = extension_first_rep
        if id_element is not None:
            self.id_element = id_element
        if id_base is not None:
            self.id_base = id_base
        if primitive is not None:
            self.primitive = primitive
        if resource is not None:
            self.resource = resource
        if boolean_primitive is not None:
            self.boolean_primitive = boolean_primitive
        if date_time is not None:
            self.date_time = date_time

    @property
    def format_comments_pre(self):
        """Gets the format_comments_pre of this ConceptMapGroupComponent.  # noqa: E501


        :return: The format_comments_pre of this ConceptMapGroupComponent.  # noqa: E501
        :rtype: list[str]
        """
        return self._format_comments_pre

    @format_comments_pre.setter
    def format_comments_pre(self, format_comments_pre):
        """Sets the format_comments_pre of this ConceptMapGroupComponent.


        :param format_comments_pre: The format_comments_pre of this ConceptMapGroupComponent.  # noqa: E501
        :type: list[str]
        """

        self._format_comments_pre = format_comments_pre

    @property
    def format_comments_post(self):
        """Gets the format_comments_post of this ConceptMapGroupComponent.  # noqa: E501


        :return: The format_comments_post of this ConceptMapGroupComponent.  # noqa: E501
        :rtype: list[str]
        """
        return self._format_comments_post

    @format_comments_post.setter
    def format_comments_post(self, format_comments_post):
        """Sets the format_comments_post of this ConceptMapGroupComponent.


        :param format_comments_post: The format_comments_post of this ConceptMapGroupComponent.  # noqa: E501
        :type: list[str]
        """

        self._format_comments_post = format_comments_post

    @property
    def id(self):
        """Gets the id of this ConceptMapGroupComponent.  # noqa: E501


        :return: The id of this ConceptMapGroupComponent.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ConceptMapGroupComponent.


        :param id: The id of this ConceptMapGroupComponent.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def extension(self):
        """Gets the extension of this ConceptMapGroupComponent.  # noqa: E501


        :return: The extension of this ConceptMapGroupComponent.  # noqa: E501
        :rtype: list[Extension]
        """
        return self._extension

    @extension.setter
    def extension(self, extension):
        """Sets the extension of this ConceptMapGroupComponent.


        :param extension: The extension of this ConceptMapGroupComponent.  # noqa: E501
        :type: list[Extension]
        """

        self._extension = extension

    @property
    def disallow_extensions(self):
        """Gets the disallow_extensions of this ConceptMapGroupComponent.  # noqa: E501


        :return: The disallow_extensions of this ConceptMapGroupComponent.  # noqa: E501
        :rtype: bool
        """
        return self._disallow_extensions

    @disallow_extensions.setter
    def disallow_extensions(self, disallow_extensions):
        """Sets the disallow_extensions of this ConceptMapGroupComponent.


        :param disallow_extensions: The disallow_extensions of this ConceptMapGroupComponent.  # noqa: E501
        :type: bool
        """

        self._disallow_extensions = disallow_extensions

    @property
    def modifier_extension(self):
        """Gets the modifier_extension of this ConceptMapGroupComponent.  # noqa: E501


        :return: The modifier_extension of this ConceptMapGroupComponent.  # noqa: E501
        :rtype: list[Extension]
        """
        return self._modifier_extension

    @modifier_extension.setter
    def modifier_extension(self, modifier_extension):
        """Sets the modifier_extension of this ConceptMapGroupComponent.


        :param modifier_extension: The modifier_extension of this ConceptMapGroupComponent.  # noqa: E501
        :type: list[Extension]
        """

        self._modifier_extension = modifier_extension

    @property
    def source(self):
        """Gets the source of this ConceptMapGroupComponent.  # noqa: E501


        :return: The source of this ConceptMapGroupComponent.  # noqa: E501
        :rtype: str
        """
        return self._source

    @source.setter
    def source(self, source):
        """Sets the source of this ConceptMapGroupComponent.


        :param source: The source of this ConceptMapGroupComponent.  # noqa: E501
        :type: str
        """

        self._source = source

    @property
    def source_version(self):
        """Gets the source_version of this ConceptMapGroupComponent.  # noqa: E501


        :return: The source_version of this ConceptMapGroupComponent.  # noqa: E501
        :rtype: str
        """
        return self._source_version

    @source_version.setter
    def source_version(self, source_version):
        """Sets the source_version of this ConceptMapGroupComponent.


        :param source_version: The source_version of this ConceptMapGroupComponent.  # noqa: E501
        :type: str
        """

        self._source_version = source_version

    @property
    def target(self):
        """Gets the target of this ConceptMapGroupComponent.  # noqa: E501


        :return: The target of this ConceptMapGroupComponent.  # noqa: E501
        :rtype: str
        """
        return self._target

    @target.setter
    def target(self, target):
        """Sets the target of this ConceptMapGroupComponent.


        :param target: The target of this ConceptMapGroupComponent.  # noqa: E501
        :type: str
        """

        self._target = target

    @property
    def target_version(self):
        """Gets the target_version of this ConceptMapGroupComponent.  # noqa: E501


        :return: The target_version of this ConceptMapGroupComponent.  # noqa: E501
        :rtype: str
        """
        return self._target_version

    @target_version.setter
    def target_version(self, target_version):
        """Sets the target_version of this ConceptMapGroupComponent.


        :param target_version: The target_version of this ConceptMapGroupComponent.  # noqa: E501
        :type: str
        """

        self._target_version = target_version

    @property
    def element(self):
        """Gets the element of this ConceptMapGroupComponent.  # noqa: E501


        :return: The element of this ConceptMapGroupComponent.  # noqa: E501
        :rtype: list[SourceElementComponent]
        """
        return self._element

    @element.setter
    def element(self, element):
        """Sets the element of this ConceptMapGroupComponent.


        :param element: The element of this ConceptMapGroupComponent.  # noqa: E501
        :type: list[SourceElementComponent]
        """

        self._element = element

    @property
    def unmapped(self):
        """Gets the unmapped of this ConceptMapGroupComponent.  # noqa: E501


        :return: The unmapped of this ConceptMapGroupComponent.  # noqa: E501
        :rtype: ConceptMapGroupUnmappedComponent
        """
        return self._unmapped

    @unmapped.setter
    def unmapped(self, unmapped):
        """Sets the unmapped of this ConceptMapGroupComponent.


        :param unmapped: The unmapped of this ConceptMapGroupComponent.  # noqa: E501
        :type: ConceptMapGroupUnmappedComponent
        """

        self._unmapped = unmapped

    @property
    def source_element(self):
        """Gets the source_element of this ConceptMapGroupComponent.  # noqa: E501


        :return: The source_element of this ConceptMapGroupComponent.  # noqa: E501
        :rtype: UriType
        """
        return self._source_element

    @source_element.setter
    def source_element(self, source_element):
        """Sets the source_element of this ConceptMapGroupComponent.


        :param source_element: The source_element of this ConceptMapGroupComponent.  # noqa: E501
        :type: UriType
        """

        self._source_element = source_element

    @property
    def source_version_element(self):
        """Gets the source_version_element of this ConceptMapGroupComponent.  # noqa: E501


        :return: The source_version_element of this ConceptMapGroupComponent.  # noqa: E501
        :rtype: StringType
        """
        return self._source_version_element

    @source_version_element.setter
    def source_version_element(self, source_version_element):
        """Sets the source_version_element of this ConceptMapGroupComponent.


        :param source_version_element: The source_version_element of this ConceptMapGroupComponent.  # noqa: E501
        :type: StringType
        """

        self._source_version_element = source_version_element

    @property
    def target_element(self):
        """Gets the target_element of this ConceptMapGroupComponent.  # noqa: E501


        :return: The target_element of this ConceptMapGroupComponent.  # noqa: E501
        :rtype: UriType
        """
        return self._target_element

    @target_element.setter
    def target_element(self, target_element):
        """Sets the target_element of this ConceptMapGroupComponent.


        :param target_element: The target_element of this ConceptMapGroupComponent.  # noqa: E501
        :type: UriType
        """

        self._target_element = target_element

    @property
    def target_version_element(self):
        """Gets the target_version_element of this ConceptMapGroupComponent.  # noqa: E501


        :return: The target_version_element of this ConceptMapGroupComponent.  # noqa: E501
        :rtype: StringType
        """
        return self._target_version_element

    @target_version_element.setter
    def target_version_element(self, target_version_element):
        """Sets the target_version_element of this ConceptMapGroupComponent.


        :param target_version_element: The target_version_element of this ConceptMapGroupComponent.  # noqa: E501
        :type: StringType
        """

        self._target_version_element = target_version_element

    @property
    def element_first_rep(self):
        """Gets the element_first_rep of this ConceptMapGroupComponent.  # noqa: E501


        :return: The element_first_rep of this ConceptMapGroupComponent.  # noqa: E501
        :rtype: SourceElementComponent
        """
        return self._element_first_rep

    @element_first_rep.setter
    def element_first_rep(self, element_first_rep):
        """Sets the element_first_rep of this ConceptMapGroupComponent.


        :param element_first_rep: The element_first_rep of this ConceptMapGroupComponent.  # noqa: E501
        :type: SourceElementComponent
        """

        self._element_first_rep = element_first_rep

    @property
    def empty(self):
        """Gets the empty of this ConceptMapGroupComponent.  # noqa: E501


        :return: The empty of this ConceptMapGroupComponent.  # noqa: E501
        :rtype: bool
        """
        return self._empty

    @empty.setter
    def empty(self, empty):
        """Sets the empty of this ConceptMapGroupComponent.


        :param empty: The empty of this ConceptMapGroupComponent.  # noqa: E501
        :type: bool
        """

        self._empty = empty

    @property
    def modifier_extension_first_rep(self):
        """Gets the modifier_extension_first_rep of this ConceptMapGroupComponent.  # noqa: E501


        :return: The modifier_extension_first_rep of this ConceptMapGroupComponent.  # noqa: E501
        :rtype: Extension
        """
        return self._modifier_extension_first_rep

    @modifier_extension_first_rep.setter
    def modifier_extension_first_rep(self, modifier_extension_first_rep):
        """Sets the modifier_extension_first_rep of this ConceptMapGroupComponent.


        :param modifier_extension_first_rep: The modifier_extension_first_rep of this ConceptMapGroupComponent.  # noqa: E501
        :type: Extension
        """

        self._modifier_extension_first_rep = modifier_extension_first_rep

    @property
    def extension_first_rep(self):
        """Gets the extension_first_rep of this ConceptMapGroupComponent.  # noqa: E501


        :return: The extension_first_rep of this ConceptMapGroupComponent.  # noqa: E501
        :rtype: Extension
        """
        return self._extension_first_rep

    @extension_first_rep.setter
    def extension_first_rep(self, extension_first_rep):
        """Sets the extension_first_rep of this ConceptMapGroupComponent.


        :param extension_first_rep: The extension_first_rep of this ConceptMapGroupComponent.  # noqa: E501
        :type: Extension
        """

        self._extension_first_rep = extension_first_rep

    @property
    def id_element(self):
        """Gets the id_element of this ConceptMapGroupComponent.  # noqa: E501


        :return: The id_element of this ConceptMapGroupComponent.  # noqa: E501
        :rtype: StringType
        """
        return self._id_element

    @id_element.setter
    def id_element(self, id_element):
        """Sets the id_element of this ConceptMapGroupComponent.


        :param id_element: The id_element of this ConceptMapGroupComponent.  # noqa: E501
        :type: StringType
        """

        self._id_element = id_element

    @property
    def id_base(self):
        """Gets the id_base of this ConceptMapGroupComponent.  # noqa: E501


        :return: The id_base of this ConceptMapGroupComponent.  # noqa: E501
        :rtype: str
        """
        return self._id_base

    @id_base.setter
    def id_base(self, id_base):
        """Sets the id_base of this ConceptMapGroupComponent.


        :param id_base: The id_base of this ConceptMapGroupComponent.  # noqa: E501
        :type: str
        """

        self._id_base = id_base

    @property
    def primitive(self):
        """Gets the primitive of this ConceptMapGroupComponent.  # noqa: E501


        :return: The primitive of this ConceptMapGroupComponent.  # noqa: E501
        :rtype: bool
        """
        return self._primitive

    @primitive.setter
    def primitive(self, primitive):
        """Sets the primitive of this ConceptMapGroupComponent.


        :param primitive: The primitive of this ConceptMapGroupComponent.  # noqa: E501
        :type: bool
        """

        self._primitive = primitive

    @property
    def resource(self):
        """Gets the resource of this ConceptMapGroupComponent.  # noqa: E501


        :return: The resource of this ConceptMapGroupComponent.  # noqa: E501
        :rtype: bool
        """
        return self._resource

    @resource.setter
    def resource(self, resource):
        """Sets the resource of this ConceptMapGroupComponent.


        :param resource: The resource of this ConceptMapGroupComponent.  # noqa: E501
        :type: bool
        """

        self._resource = resource

    @property
    def boolean_primitive(self):
        """Gets the boolean_primitive of this ConceptMapGroupComponent.  # noqa: E501


        :return: The boolean_primitive of this ConceptMapGroupComponent.  # noqa: E501
        :rtype: bool
        """
        return self._boolean_primitive

    @boolean_primitive.setter
    def boolean_primitive(self, boolean_primitive):
        """Sets the boolean_primitive of this ConceptMapGroupComponent.


        :param boolean_primitive: The boolean_primitive of this ConceptMapGroupComponent.  # noqa: E501
        :type: bool
        """

        self._boolean_primitive = boolean_primitive

    @property
    def date_time(self):
        """Gets the date_time of this ConceptMapGroupComponent.  # noqa: E501


        :return: The date_time of this ConceptMapGroupComponent.  # noqa: E501
        :rtype: bool
        """
        return self._date_time

    @date_time.setter
    def date_time(self, date_time):
        """Sets the date_time of this ConceptMapGroupComponent.


        :param date_time: The date_time of this ConceptMapGroupComponent.  # noqa: E501
        :type: bool
        """

        self._date_time = date_time

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ConceptMapGroupComponent):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
